#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityChipBoxLottery.h"
std::auto_ptr<M_ActivityChipBoxLottery> M_ActivityChipBoxLottery::msSingleton(nullptr);

int M_ActivityChipBoxLottery::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityChipBoxLotteryData* M_ActivityChipBoxLottery::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityChipBoxLotteryData>& M_ActivityChipBoxLottery::GetMapData()
{
	return mMapData;
}

void M_ActivityChipBoxLottery::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityChipBoxLottery.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityChipBoxLotteryData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mWeight = element->IntAttribute("Weight");
		data.mDropItem = element->IntAttribute("DropItem");
		data.mDropCount = element->IntAttribute("DropCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityChipBoxLottery Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityChipBoxLottery::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityChipBoxLottery");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityChipBoxLottery");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityChipBoxLotteryData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		LuaCfgHelper::readInt(L, "DropItem", data.mDropItem);
		LuaCfgHelper::readInt(L, "DropCount", data.mDropCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityChipBoxLottery Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityChipBoxLottery::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityChipBoxLottery* M_ActivityChipBoxLottery::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityChipBoxLottery());
	}
	return msSingleton.get();
}

void M_ActivityChipBoxLottery::Release()
{
	msSingleton.reset(nullptr);
}
